"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .objectpermissions import ObjectPermissions, ObjectPermissionsTypedDict
from .person import Person, PersonTypedDict
from glean.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class AgentTypedDict(TypedDict):
    author: NotRequired[PersonTypedDict]
    create_timestamp: NotRequired[int]
    r"""Server Unix timestamp of the creation time."""
    last_update_timestamp: NotRequired[int]
    r"""Server Unix timestamp of the last update time."""
    last_updated_by: NotRequired[PersonTypedDict]
    id: NotRequired[str]
    r"""The ID of the agent."""
    name: NotRequired[str]
    r"""The name of the agent."""
    permissions: NotRequired[ObjectPermissionsTypedDict]


class Agent(BaseModel):
    author: Optional[Person] = None

    create_timestamp: Annotated[
        Optional[int], pydantic.Field(alias="createTimestamp")
    ] = None
    r"""Server Unix timestamp of the creation time."""

    last_update_timestamp: Annotated[
        Optional[int], pydantic.Field(alias="lastUpdateTimestamp")
    ] = None
    r"""Server Unix timestamp of the last update time."""

    last_updated_by: Annotated[
        Optional[Person], pydantic.Field(alias="lastUpdatedBy")
    ] = None

    id: Optional[str] = None
    r"""The ID of the agent."""

    name: Optional[str] = None
    r"""The name of the agent."""

    permissions: Optional[ObjectPermissions] = None
