"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from glean.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class AppResultTypedDict(TypedDict):
    datasource: str
    r"""The app or other repository type this represents"""
    doc_type: NotRequired[str]
    r"""The datasource-specific type of the document (e.g. for Jira issues, this is the issue type such as Bug or Feature Request)."""
    mime_type: NotRequired[str]
    r"""Mimetype is used to differentiate between sub applications from a datasource (e.g. Sheets, Docs from Gdrive)"""
    icon_url: NotRequired[str]
    r"""If there is available icon URL."""


class AppResult(BaseModel):
    datasource: str
    r"""The app or other repository type this represents"""

    doc_type: Annotated[Optional[str], pydantic.Field(alias="docType")] = None
    r"""The datasource-specific type of the document (e.g. for Jira issues, this is the issue type such as Bug or Feature Request)."""

    mime_type: Annotated[Optional[str], pydantic.Field(alias="mimeType")] = None
    r"""Mimetype is used to differentiate between sub applications from a datasource (e.g. Sheets, Docs from Gdrive)"""

    icon_url: Annotated[Optional[str], pydantic.Field(alias="iconUrl")] = None
    r"""If there is available icon URL."""
