"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .chatrequest import ChatRequest, ChatRequestTypedDict
from glean.types import BaseModel
from glean.utils import FieldMetadata, QueryParamMetadata, RequestMetadata
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ChatStreamRequestTypedDict(TypedDict):
    chat_request: ChatRequestTypedDict
    r"""Includes chat history for Glean AI to respond to."""
    timezone_offset: NotRequired[int]
    r"""The offset of the client's timezone in minutes from UTC. e.g. PDT is -420 because it's 7 hours behind UTC."""


class ChatStreamRequest(BaseModel):
    chat_request: Annotated[
        ChatRequest,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]
    r"""Includes chat history for Glean AI to respond to."""

    timezone_offset: Annotated[
        Optional[int],
        pydantic.Field(alias="timezoneOffset"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""The offset of the client's timezone in minutes from UTC. e.g. PDT is -420 because it's 7 hours behind UTC."""
