"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from enum import Enum
from glean.types import BaseModel
import pydantic
from typing import Optional, TYPE_CHECKING
from typing_extensions import Annotated, NotRequired, TypedDict

if TYPE_CHECKING:
    from .collection import Collection, CollectionTypedDict
    from .document import Document, DocumentTypedDict
    from .person import Person, PersonTypedDict
    from .shortcut import Shortcut, ShortcutTypedDict


class CollectionItemItemType(str, Enum):
    DOCUMENT = "DOCUMENT"
    TEXT = "TEXT"
    URL = "URL"
    COLLECTION = "COLLECTION"


class CollectionItemTypedDict(TypedDict):
    collection_id: int
    r"""The Collection ID of the Collection that this CollectionItem belongs in."""
    item_type: CollectionItemItemType
    name: NotRequired[str]
    r"""The optional name of the Collection item."""
    description: NotRequired[str]
    r"""A helpful description of why this CollectionItem is in the Collection that it's in."""
    icon: NotRequired[str]
    r"""The emoji icon for this CollectionItem. Only used for Text type items."""
    document_id: NotRequired[str]
    r"""If this CollectionItem is indexed, the Glean Document ID of that document."""
    url: NotRequired[str]
    r"""The URL of this CollectionItem."""
    item_id: NotRequired[str]
    r"""Unique identifier for the item within the Collection it belongs to."""
    created_by: NotRequired["PersonTypedDict"]
    created_at: NotRequired[datetime]
    r"""Unix timestamp for when the item was first added (in seconds since epoch UTC)."""
    document: NotRequired["DocumentTypedDict"]
    shortcut: NotRequired["ShortcutTypedDict"]
    collection: NotRequired["CollectionTypedDict"]


class CollectionItem(BaseModel):
    collection_id: Annotated[int, pydantic.Field(alias="collectionId")]
    r"""The Collection ID of the Collection that this CollectionItem belongs in."""

    item_type: Annotated[CollectionItemItemType, pydantic.Field(alias="itemType")]

    name: Optional[str] = None
    r"""The optional name of the Collection item."""

    description: Optional[str] = None
    r"""A helpful description of why this CollectionItem is in the Collection that it's in."""

    icon: Optional[str] = None
    r"""The emoji icon for this CollectionItem. Only used for Text type items."""

    document_id: Annotated[Optional[str], pydantic.Field(alias="documentId")] = None
    r"""If this CollectionItem is indexed, the Glean Document ID of that document."""

    url: Optional[str] = None
    r"""The URL of this CollectionItem."""

    item_id: Annotated[Optional[str], pydantic.Field(alias="itemId")] = None
    r"""Unique identifier for the item within the Collection it belongs to."""

    created_by: Annotated[Optional["Person"], pydantic.Field(alias="createdBy")] = None

    created_at: Annotated[Optional[datetime], pydantic.Field(alias="createdAt")] = None
    r"""Unix timestamp for when the item was first added (in seconds since epoch UTC)."""

    document: Optional["Document"] = None

    shortcut: Optional["Shortcut"] = None

    collection: Optional["Collection"] = None
