"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .useractivityinsight import UserActivityInsight, UserActivityInsightTypedDict
from glean.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class GleanAssistInsightsResponseTypedDict(TypedDict):
    last_log_timestamp: NotRequired[int]
    r"""Unix timestamp of the last activity processed to make the response (in seconds since epoch UTC)."""
    activity_insights: NotRequired[List[UserActivityInsightTypedDict]]
    r"""Insights for all active users with respect to set of actions."""
    total_active_users: NotRequired[int]
    r"""Total number of active users in the requested period."""
    datasource_instances: NotRequired[List[str]]
    r"""List of datasource instances for which glean assist is enabled."""
    departments: NotRequired[List[str]]
    r"""List of departments applicable for users tab."""


class GleanAssistInsightsResponse(BaseModel):
    last_log_timestamp: Annotated[
        Optional[int], pydantic.Field(alias="lastLogTimestamp")
    ] = None
    r"""Unix timestamp of the last activity processed to make the response (in seconds since epoch UTC)."""

    activity_insights: Annotated[
        Optional[List[UserActivityInsight]], pydantic.Field(alias="activityInsights")
    ] = None
    r"""Insights for all active users with respect to set of actions."""

    total_active_users: Annotated[
        Optional[int], pydantic.Field(alias="totalActiveUsers")
    ] = None
    r"""Total number of active users in the requested period."""

    datasource_instances: Annotated[
        Optional[List[str]], pydantic.Field(alias="datasourceInstances")
    ] = None
    r"""List of datasource instances for which glean assist is enabled."""

    departments: Optional[List[str]] = None
    r"""List of departments applicable for users tab."""
