"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .insightsagentsrequestoptions import (
    InsightsAgentsRequestOptions,
    InsightsAgentsRequestOptionsTypedDict,
)
from .insightsaiapprequestoptions import (
    InsightsAiAppRequestOptions,
    InsightsAiAppRequestOptionsTypedDict,
)
from .period import Period, PeriodTypedDict
from enum import Enum
from glean.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class InsightsRequestCategory(str, Enum):
    AGENTS = "AGENTS"
    AI = "AI"
    AI_APPS = "AI_APPS"
    ANNOUNCEMENTS = "ANNOUNCEMENTS"
    ANSWERS = "ANSWERS"
    COLLECTIONS = "COLLECTIONS"
    CONTENT = "CONTENT"
    GLEAN_ASSIST = "GLEAN_ASSIST"
    QUERIES = "QUERIES"
    SHORTCUTS = "SHORTCUTS"
    USERS = "USERS"


class AssistantActivityType(str, Enum):
    GLEAN_CHAT = "GLEAN_CHAT"
    AI_SUMMARY = "AI_SUMMARY"
    AI_ANSWER = "AI_ANSWER"
    GLEANBOT_RESPONSE = "GLEANBOT_RESPONSE"


class InsightsRequestTypedDict(TypedDict):
    categories: List[InsightsRequestCategory]
    r"""Categories of data requested. Request can include single or multiple types."""
    departments: NotRequired[List[str]]
    r"""Departments that the data is requested for. If this is empty, corresponds to whole company."""
    day_range: NotRequired[PeriodTypedDict]
    ai_app_request_options: NotRequired[InsightsAiAppRequestOptionsTypedDict]
    agents_request_options: NotRequired[InsightsAgentsRequestOptionsTypedDict]
    assistant_activity_types: NotRequired[List[AssistantActivityType]]
    r"""Types of activity that should count in the definition of an Assistant Active User. Affects only insights for AI category."""
    disable_per_user_insights: NotRequired[bool]
    r"""If true, suppresses the generation of per-user Insights in the response. Default is false."""


class InsightsRequest(BaseModel):
    categories: List[InsightsRequestCategory]
    r"""Categories of data requested. Request can include single or multiple types."""

    departments: Optional[List[str]] = None
    r"""Departments that the data is requested for. If this is empty, corresponds to whole company."""

    day_range: Annotated[Optional[Period], pydantic.Field(alias="dayRange")] = None

    ai_app_request_options: Annotated[
        Optional[InsightsAiAppRequestOptions],
        pydantic.Field(alias="aiAppRequestOptions"),
    ] = None

    agents_request_options: Annotated[
        Optional[InsightsAgentsRequestOptions],
        pydantic.Field(alias="agentsRequestOptions"),
    ] = None

    assistant_activity_types: Annotated[
        Optional[List[AssistantActivityType]],
        pydantic.Field(alias="assistantActivityTypes"),
    ] = None
    r"""Types of activity that should count in the definition of an Assistant Active User. Affects only insights for AI category."""

    disable_per_user_insights: Annotated[
        Optional[bool], pydantic.Field(alias="disablePerUserInsights")
    ] = None
    r"""If true, suppresses the generation of per-user Insights in the response. Default is false."""
