"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from glean.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ReminderRequestTypedDict(TypedDict):
    document_id: str
    r"""The document which the verification is for new reminders and/or update."""
    assignee: NotRequired[str]
    r"""The obfuscated id of the person this verification is assigned to."""
    remind_in_days: NotRequired[int]
    r"""Reminder for the next verifications in terms of days. For deletion, this will be omitted."""
    reason: NotRequired[str]
    r"""An optional free-text reason for the reminder. This is particularly useful when a reminder is used to ask for verification from another user (for example, \"Duplicate\", \"Incomplete\", \"Incorrect\")."""


class ReminderRequest(BaseModel):
    document_id: Annotated[str, pydantic.Field(alias="documentId")]
    r"""The document which the verification is for new reminders and/or update."""

    assignee: Optional[str] = None
    r"""The obfuscated id of the person this verification is assigned to."""

    remind_in_days: Annotated[Optional[int], pydantic.Field(alias="remindInDays")] = (
        None
    )
    r"""Reminder for the next verifications in terms of days. For deletion, this will be omitted."""

    reason: Optional[str] = None
    r"""An optional free-text reason for the reminder. This is particularly useful when a reminder is used to ask for verification from another user (for example, \"Duplicate\", \"Incomplete\", \"Incorrect\")."""
